/**************************************************************/
/*     File: C_int_handler.c                                  */
/*  Purpose: IRQ interrupt handler code                       */
/**************************************************************/

#include "stand.h"


/******************************************************************************
* IRQHandler                                                                  *
* This function handles IRQ interrupts.  In this example, these may come from *
* Timer 1, Timer 2 and the Parallel Port (generated by the switch S3).        *
* This handler simply clears the interrupt and sets correspondings flags.     *
* These flags are then checked by the main application.                       *
*******************************************************************************/

void __irq IRQHandler(void)
{
    unsigned status, i;
         
    status = *IRQStatus;
    /* Deal with source of interrupt */
    /* RMC source definitions used for CT1, CT2 and PAR */
        
    if (status & IRQTimer1)
    {
        *Timer1Clear = 0;/* clear the interrupt */
        IntCT1++;        /* set the flag        */
    } 
    else if (status & IRQTimer2)
    {
        *Timer2Clear = 0;/* clear the interrupt */
        IntCT2++;        /* set the flag        */
    } 
    else if (status & IRQSourcePAR)
    {
        i = *ParStat;    /* clear the interrupt */
        IntPAR++;        /* set the flag        */
    }
}


