/* errors.h - List of all ARMulator errors
 * (c) 1996 Advanced RISC Machines Limited. All Rights Reserved.
 *
 * RCS $Revision: 1.3 $
 * Checkin $Date: 1997/03/25 13:15:18 $
 * Revising $Author: mwilliam $
 */

/*
 * This file, like "models.h", is just a list of macros. There is a
 * limit of 2048 messages in total. The order of the messages is
 * important - new ones must be added to the end.
 */

ERROR(ARMulErr_OutOfMemory, "Out of memory.")

/* Initialisation failures */
ERROR(ARMulErr_NoConfigFile, "Could not read ARMulator configuration file ('armul.cnf.').")
ERROR(ARMulErr_NoConfig, "No configuration found (bad configuration file).")
ERROR(ARMulErr_NoConfigFor, "No configuration for '%s' found.")
ERROR(ARMulErr_NoConfigProc, "No configuration for 'PROCESSORS' found.")
ERROR(ARMulErr_NoConfigCop, "No configuration for 'COPROCESSORS' found.")
ERROR(ARMulErr_NoConfigTarget, "No configuration for target '%s' found.")
ERROR(ARMulErr_NoConfigARMulator, "No ARMulator configured for target '%s' found.")

ERROR(ARMulErr_NoSuchARMulator, "Could not find configured ARMulator '%s'.")
ERROR(ARMulErr_NoSuchCore, "Could not find configured Core '%s'.")

ERROR(ARMulErr_Inconsistent, "Configuration is inconsistent.")
ERROR(ARMulErr_IncompatibleOptions, "Configuration options '%s' and '%s' are mutually incompatible.")

ERROR(ARMulErr_NoProcessorType, "No processor type configured.")
ERROR(ARMulErr_NoCoreType, "No processor-core type configured.")
ERROR(ARMulErr_NoMemoryType, "No memory interface configured.")
ERROR(ARMulErr_NoCopType, "No co-processor bus interface configured.")

ERROR(ARMulErr_NoImageFile, "No Imagefile specified.")
ERROR(ARMulErr_CouldNotOpenImage, "Could not open image '%s'.")
ERROR(ARMulErr_BadAIFHeader, "Could not read AIF header in image '%s'.")

ERROR(ARMulErr_InitFailMemory, "Memory interface failed to initialise.")
ERROR(ARMulErr_InitFailCop, "Co-processor interface failed to initialise.")
ERROR(ARMulErr_InitFailOS, "Operating System interface failed to initialise.")
ERROR(ARMulErr_InitFailModels, "Models failed to initialise.")
ERROR(ARMulErr_InitFailPU, "Prefetch Unit failed to initialise.")

ERROR(ARMulErr_NoMemoryChild, "Memory model '%s' needs to have a child configured.")
ERROR(ARMulErr_MemTypeUnhandled, "Memory model '%s' incompatible with bus interface.")

ERROR(ARMulErr_CoProAttached, "Attempt to attach more than one co-processor to a given interface.")
ERROR(ARMulErr_CoProIsBus, "Attempt to attach co-processor bus model '%s' as a co-processor.")
ERROR(ARMulErr_CoProNumber, "Co-processor model '%s' must be CP%d.")

/* Model errors */
ERROR(ARMulErr_DemonChildren, "(Demon) Children failed to initialise.")
ERROR(ARMulErr_AngelHeap, "(Angel) Configured HeapBase (0x%08x) >= HeapLimit (0x%08x).")
ERROR(ARMulErr_AngelStack, "(Angel) Configured StackBase (0x%08x) <= StackLimit (0x%08x).")
ERROR(ARMulErr_AngelHeapStack, "(Angel) Configured Stack (0x%08s->0x%08x) and Heap (0x%08x->0x%08x) overlap.")

ERROR(ARMulErr_SMMUCacheLines, "(StrongARM MMU) I/DCACHE_LINES must be a power of 2.")
ERROR(ARMulErr_SMMUCacheAssoc, "(StrongARM MMU) I/DCACHE_ASSOCIATIVITY must be a power of 2.")
